Index: uspace/app/websrv/websrv.c
===================================================================
--- uspace/app/websrv/websrv.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/app/websrv/websrv.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -44,7 +44,7 @@
 #include <task.h>
 
-#include <net/in.h>
-#include <net/inet.h>
-#include <net/socket.h>
+#include <inet/addr.h>
+#include <inet/endpoint.h>
+#include <inet/tcp.h>
 
 #include <arg_parse.h>
@@ -56,5 +56,4 @@
 
 #define DEFAULT_PORT  8080
-#define BACKLOG_SIZE  3
 
 #define WEB_ROOT  "/data/web"
@@ -62,4 +61,14 @@
 /** Buffer for receiving the request. */
 #define BUFFER_SIZE  1024
+
+static void websrv_new_conn(tcp_listener_t *, tcp_conn_t *);
+
+static tcp_listen_cb_t listen_cb = {
+	.new_conn = websrv_new_conn
+};
+
+static tcp_cb_t conn_cb = {
+	.connected = NULL
+};
 
 static uint16_t port = DEFAULT_PORT;
@@ -122,17 +131,20 @@
 
 /** Receive one character (with buffering) */
-static int recv_char(int fd, char *c)
-{
+static int recv_char(tcp_conn_t *conn, char *c)
+{
+	size_t nrecv;
+	int rc;
+	
 	if (rbuf_out == rbuf_in) {
 		rbuf_out = 0;
 		rbuf_in = 0;
 		
-		ssize_t rc = recv(fd, rbuf, BUFFER_SIZE, 0);
-		if (rc <= 0) {
-			fprintf(stderr, "recv() failed (%zd)\n", rc);
+		rc = tcp_conn_recv_wait(conn, rbuf, BUFFER_SIZE, &nrecv);
+		if (rc != EOK) {
+			fprintf(stderr, "tcp_conn_recv() failed (%d)\n", rc);
 			return rc;
 		}
 		
-		rbuf_in = rc;
+		rbuf_in = nrecv;
 	}
 	
@@ -142,5 +154,5 @@
 
 /** Receive one line with length limit */
-static int recv_line(int fd)
+static int recv_line(tcp_conn_t *conn)
 {
 	char *bp = lbuf;
@@ -149,5 +161,5 @@
 	while (bp < lbuf + BUFFER_SIZE) {
 		char prev = c;
-		int rc = recv_char(fd, &c);
+		int rc = recv_char(conn, &c);
 		
 		if (rc != EOK)
@@ -187,5 +199,5 @@
 }
 
-static int send_response(int conn_sd, const char *msg)
+static int send_response(tcp_conn_t *conn, const char *msg)
 {
 	size_t response_size = str_size(msg);
@@ -194,7 +206,7 @@
 	    fprintf(stderr, "Sending response\n");
 	
-	ssize_t rc = send(conn_sd, (void *) msg, response_size, 0);
-	if (rc < 0) {
-		fprintf(stderr, "send() failed\n");
+	int rc = tcp_conn_send(conn, (void *) msg, response_size);
+	if (rc != EOK) {
+		fprintf(stderr, "tcp_conn_send() failed\n");
 		return rc;
 	}
@@ -203,5 +215,5 @@
 }
 
-static int uri_get(const char *uri, int conn_sd)
+static int uri_get(const char *uri, tcp_conn_t *conn)
 {
 	if (str_cmp(uri, "/") == 0)
@@ -215,5 +227,5 @@
 	int fd = open(fname, O_RDONLY);
 	if (fd < 0) {
-		rc = send_response(conn_sd, msg_not_found);
+		rc = send_response(conn, msg_not_found);
 		free(fname);
 		return rc;
@@ -222,5 +234,5 @@
 	free(fname);
 	
-	rc = send_response(conn_sd, msg_ok);
+	rc = send_response(conn, msg_ok);
 	if (rc != EOK)
 		return rc;
@@ -236,7 +248,7 @@
 		}
 		
-		rc = send(conn_sd, fbuf, nr, 0);
-		if (rc < 0) {
-			fprintf(stderr, "send() failed\n");
+		rc = tcp_conn_send(conn, fbuf, nr);
+		if (rc != EOK) {
+			fprintf(stderr, "tcp_conn_send() failed\n");
 			close(fd);
 			return rc;
@@ -249,7 +261,7 @@
 }
 
-static int req_process(int conn_sd)
-{
-	int rc = recv_line(conn_sd);
+static int req_process(tcp_conn_t *conn)
+{
+	int rc = recv_line(conn);
 	if (rc != EOK) {
 		fprintf(stderr, "recv_line() failed\n");
@@ -261,5 +273,5 @@
 	
 	if (str_lcmp(lbuf, "GET ", 4) != 0) {
-		rc = send_response(conn_sd, msg_not_implemented);
+		rc = send_response(conn, msg_not_implemented);
 		return rc;
 	}
@@ -277,9 +289,9 @@
 	
 	if (!uri_is_valid(uri)) {
-		rc = send_response(conn_sd, msg_bad_request);
-		return rc;
-	}
-	
-	return uri_get(uri, conn_sd);
+		rc = send_response(conn, msg_bad_request);
+		return rc;
+	}
+	
+	return uri_get(uri, conn);
 }
 
@@ -346,10 +358,39 @@
 }
 
+static void websrv_new_conn(tcp_listener_t *lst, tcp_conn_t *conn)
+{
+	int rc;
+	
+	if (verbose)
+		fprintf(stderr, "New connection, waiting for request\n");
+	
+	rbuf_out = 0;
+	rbuf_in = 0;
+	
+	rc = req_process(conn);
+	if (rc != EOK) {
+		fprintf(stderr, "Error processing request (%s)\n",
+		    str_error(rc));
+		return;
+	}
+
+	rc = tcp_conn_send_fin(conn);
+	if (rc != EOK) {
+		fprintf(stderr, "Error sending FIN.\n");
+		return;
+	}
+}
+
 int main(int argc, char *argv[])
 {
+	inet_ep_t ep;
+	tcp_listener_t *lst;
+	tcp_t *tcp;
+	int rc;
+	
 	/* Parse command line arguments */
 	for (int i = 1; i < argc; i++) {
 		if (argv[i][0] == '-') {
-			int rc = parse_option(argc, argv, &i);
+			rc = parse_option(argc, argv, &i);
 			if (rc != EOK)
 				return rc;
@@ -360,40 +401,23 @@
 	}
 	
-	struct sockaddr_in addr;
-	
-	addr.sin_family = AF_INET;
-	addr.sin_port = htons(port);
-	
-	int rc = inet_pton(AF_INET, "127.0.0.1", (void *)
-	    &addr.sin_addr.s_addr);
-	if (rc != EOK) {
-		fprintf(stderr, "Error parsing network address (%s)\n",
-		    str_error(rc));
+	printf("%s: HelenOS web server\n", NAME);
+
+	if (verbose)
+		fprintf(stderr, "Creating listener\n");
+	
+	inet_ep_init(&ep);
+	ep.port = port;
+
+	rc = tcp_create(&tcp);
+	if (rc != EOK) {
+		fprintf(stderr, "Error initializing TCP.\n");
 		return 1;
 	}
-	
-	printf("%s: HelenOS web server\n", NAME);
-
-	if (verbose)
-		fprintf(stderr, "Creating socket\n");
-	
-	int listen_sd = socket(PF_INET, SOCK_STREAM, 0);
-	if (listen_sd < 0) {
-		fprintf(stderr, "Error creating listening socket (%s)\n",
-		    str_error(listen_sd));
+
+	rc = tcp_listener_create(tcp, &ep, &listen_cb, NULL, &conn_cb, NULL,
+	    &lst);
+	if (rc != EOK) {
+		fprintf(stderr, "Error creating listener.\n");
 		return 2;
-	}
-	
-	rc = bind(listen_sd, (struct sockaddr *) &addr, sizeof(addr));
-	if (rc != EOK) {
-		fprintf(stderr, "Error binding socket (%s)\n",
-		    str_error(rc));
-		return 3;
-	}
-	
-	rc = listen(listen_sd, BACKLOG_SIZE);
-	if (rc != EOK) {
-		fprintf(stderr, "listen() failed (%s)\n", str_error(rc));
-		return 4;
 	}
 	
@@ -402,40 +426,5 @@
 
 	task_retval(0);
-
-	while (true) {
-		struct sockaddr_in raddr;
-		socklen_t raddr_len = sizeof(raddr);
-		int conn_sd = accept(listen_sd, (struct sockaddr *) &raddr,
-		    &raddr_len);
-		
-		if (conn_sd < 0) {
-			fprintf(stderr, "accept() failed (%s)\n", str_error(rc));
-			continue;
-		}
-		
-		if (verbose) {
-			fprintf(stderr, "Connection accepted (sd=%d), "
-			    "waiting for request\n", conn_sd);
-		}
-		
-		rbuf_out = 0;
-		rbuf_in = 0;
-		
-		rc = req_process(conn_sd);
-		if (rc != EOK)
-			fprintf(stderr, "Error processing request (%s)\n",
-			    str_error(rc));
-		
-		rc = closesocket(conn_sd);
-		if (rc != EOK) {
-			fprintf(stderr, "Error closing connection socket (%s)\n",
-			    str_error(rc));
-			closesocket(listen_sd);
-			return 5;
-		}
-		
-		if (verbose)
-			fprintf(stderr, "Connection closed\n");
-	}
+	async_manager();
 	
 	/* Not reached */
Index: uspace/drv/bus/usb/usbhub/usbhub.c
===================================================================
--- uspace/drv/bus/usb/usbhub/usbhub.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/drv/bus/usb/usbhub/usbhub.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -192,5 +192,5 @@
 		if (!tries--) {
 			usb_log_error("Can't remove hub, still running.\n");
-			return EINPROGRESS;
+			return EBUSY;
 		}
 	}
Index: uspace/drv/bus/usb/vhc/devconn.c
===================================================================
--- uspace/drv/bus/usb/vhc/devconn.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/drv/bus/usb/vhc/devconn.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -32,5 +32,5 @@
 
 
-static vhc_virtdev_t *vhc_virtdev_create()
+static vhc_virtdev_t *vhc_virtdev_create(void)
 {
 	vhc_virtdev_t *dev = malloc(sizeof(vhc_virtdev_t));
Index: uspace/lib/c/Makefile
===================================================================
--- uspace/lib/c/Makefile	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/c/Makefile	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -97,4 +97,7 @@
 	generic/futex.c \
 	generic/inet/addr.c \
+	generic/inet/endpoint.c \
+	generic/inet/tcp.c \
+	generic/inet/udp.c \
 	generic/inet.c \
 	generic/inetcfg.c \
@@ -137,6 +140,4 @@
 	generic/adt/list.c \
 	generic/adt/hash_table.c \
-	generic/adt/dynamic_fifo.c \
-	generic/adt/char_map.c \
 	generic/adt/prodcons.c \
 	generic/time.c \
@@ -145,7 +146,4 @@
 	generic/vfs/vfs.c \
 	generic/vfs/canonify.c \
-	generic/net/inet.c \
-	generic/net/socket_client.c \
-	generic/net/socket_parse.c \
 	generic/setjmp.c \
 	generic/stack.c \
Index: uspace/lib/c/generic/fibril.c
===================================================================
--- uspace/lib/c/generic/fibril.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/c/generic/fibril.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -57,24 +57,11 @@
 /**
  * This futex serializes access to ready_list,
- * serialized_list and manager_list.
+ * manager_list and fibril_list.
  */
 static futex_t fibril_futex = FUTEX_INITIALIZER;
 
 static LIST_INITIALIZE(ready_list);
-static LIST_INITIALIZE(serialized_list);
 static LIST_INITIALIZE(manager_list);
 static LIST_INITIALIZE(fibril_list);
-
-/** Number of threads that are executing a manager fibril. */
-static int threads_in_manager;
-
-/**
- * Number of threads that are executing a manager fibril
- * and are serialized. Protected by async_futex.
- */
-static int serialized_threads;
-
-/** Fibril-local count of serialization. If > 0, we must not preempt */
-static fibril_local int serialization_count;
 
 /** Function that spans the whole life-cycle of a fibril.
@@ -96,4 +83,5 @@
 	fibril->retval = fibril->func(fibril->arg);
 	
+	futex_down(&async_futex);
 	fibril_switch(FIBRIL_FROM_DEAD);
 	/* Not reached */
@@ -126,12 +114,19 @@
 	
 	fibril->waits_for = NULL;
+
+	futex_lock(&fibril_futex);
 	list_append(&fibril->all_link, &fibril_list);
+	futex_unlock(&fibril_futex);
 	
 	return fibril;
 }
 
-void fibril_teardown(fibril_t *fibril)
-{
+void fibril_teardown(fibril_t *fibril, bool locked)
+{	
+	if (!locked)
+		futex_lock(&fibril_futex);
 	list_remove(&fibril->all_link);
+	if (!locked)
+		futex_unlock(&fibril_futex);
 	tls_free(fibril->tcb);
 	free(fibril);
@@ -140,6 +135,6 @@
 /** Switch from the current fibril.
  *
- * If calling with FIBRIL_TO_MANAGER parameter, the async_futex should be
- * held.
+ * If stype is FIBRIL_TO_MANAGER or FIBRIL_FROM_DEAD, the async_futex must
+ * be held.
  *
  * @param stype Switch type. One of FIBRIL_PREEMPT, FIBRIL_TO_MANAGER,
@@ -153,27 +148,20 @@
 int fibril_switch(fibril_switch_type_t stype)
 {
-	int retval = 0;
-	
-	futex_lock(&fibril_futex);
-	
-	if (stype == FIBRIL_PREEMPT && list_empty(&ready_list))
-		goto ret_0;
-	
-	if (stype == FIBRIL_FROM_MANAGER) {
-		if ((list_empty(&ready_list)) && (list_empty(&serialized_list)))
-			goto ret_0;
-		
-		/*
-		 * Do not preempt if there is not enough threads to run the
-		 * ready fibrils which are not serialized.
-		 */
-		if ((list_empty(&serialized_list)) &&
-		    (threads_in_manager <= serialized_threads)) {
-			goto ret_0;
+	futex_lock(&fibril_futex);
+
+	switch (stype) {
+	case FIBRIL_PREEMPT:
+	case FIBRIL_FROM_MANAGER:
+		if (list_empty(&ready_list)) {
+			futex_unlock(&fibril_futex);
+			return 0;
 		}
-	}
-	
-	/* If we are going to manager and none exists, create it */
-	if ((stype == FIBRIL_TO_MANAGER) || (stype == FIBRIL_FROM_DEAD)) {
+		break;
+	case FIBRIL_TO_MANAGER:
+	case FIBRIL_FROM_DEAD:
+		/* Make sure the async_futex is held. */
+		assert((atomic_signed_t) async_futex.val.count <= 0);
+
+		/* If we are going to manager and none exists, create it */
 		while (list_empty(&manager_list)) {
 			futex_unlock(&fibril_futex);
@@ -181,4 +169,5 @@
 			futex_lock(&fibril_futex);
 		}
+		break;
 	}
 	
@@ -188,7 +177,4 @@
 		/* Save current state */
 		if (!context_save(&srcf->ctx)) {
-			if (serialization_count)
-				srcf->flags &= ~FIBRIL_SERIALIZED;
-			
 			if (srcf->clean_after_me) {
 				/*
@@ -208,5 +194,5 @@
 					as_area_destroy(stack);
 				}
-				fibril_teardown(srcf->clean_after_me);
+				fibril_teardown(srcf->clean_after_me, true);
 				srcf->clean_after_me = NULL;
 			}
@@ -215,42 +201,41 @@
 		}
 		
-		/* Save myself to the correct run list */
-		if (stype == FIBRIL_PREEMPT)
+		/* Put the current fibril into the correct run list */
+		switch (stype) {
+		case FIBRIL_PREEMPT:
 			list_append(&srcf->link, &ready_list);
-		else if (stype == FIBRIL_FROM_MANAGER) {
+			break;
+		case FIBRIL_FROM_MANAGER:
 			list_append(&srcf->link, &manager_list);
-			threads_in_manager--;
-		} else {
+			break;
+		default:
+			assert(stype == FIBRIL_TO_MANAGER);
+
 			/*
-			 * If stype == FIBRIL_TO_MANAGER, don't put ourselves to
-			 * any list, we should already be somewhere, or we will
-			 * be lost.
+			 * Don't put the current fibril into any list, it should
+			 * already be somewhere, or it will be lost.
 			 */
+			break;
 		}
 	}
 	
+	fibril_t *dstf;
+
 	/* Choose a new fibril to run */
-	fibril_t *dstf;
-	if ((stype == FIBRIL_TO_MANAGER) || (stype == FIBRIL_FROM_DEAD)) {
+	switch (stype) {
+	case FIBRIL_TO_MANAGER:
+	case FIBRIL_FROM_DEAD:
 		dstf = list_get_instance(list_first(&manager_list), fibril_t,
 		    link);
-		if (serialization_count && stype == FIBRIL_TO_MANAGER) {
-			serialized_threads++;
-			srcf->flags |= FIBRIL_SERIALIZED;
-		}
-		threads_in_manager++;
 		
 		if (stype == FIBRIL_FROM_DEAD) 
 			dstf->clean_after_me = srcf;
-	} else {
-		if (!list_empty(&serialized_list)) {
-			dstf = list_get_instance(list_first(&serialized_list),
-			    fibril_t, link);
-			serialized_threads--;
-		} else {
-			dstf = list_get_instance(list_first(&ready_list),
-			    fibril_t, link);
-		}
-	}
+		break;
+	default:
+		dstf = list_get_instance(list_first(&ready_list), fibril_t,
+		    link);
+		break;
+	}
+
 	list_remove(&dstf->link);
 	
@@ -265,8 +250,4 @@
 	context_restore(&dstf->ctx);
 	/* not reached */
-	
-ret_0:
-	futex_unlock(&fibril_futex);
-	return retval;
 }
 
@@ -294,5 +275,5 @@
 	    AS_AREA_LATE_RESERVE);
 	if (fibril->stack == (void *) -1) {
-		fibril_teardown(fibril);
+		fibril_teardown(fibril, false);
 		return 0;
 	}
@@ -321,5 +302,5 @@
 	
 	as_area_destroy(fibril->stack);
-	fibril_teardown(fibril);
+	fibril_teardown(fibril, false);
 }
 
@@ -335,10 +316,5 @@
 	
 	futex_lock(&fibril_futex);
-	
-	if ((fibril->flags & FIBRIL_SERIALIZED))
-		list_append(&fibril->link, &serialized_list);
-	else
-		list_append(&fibril->link, &ready_list);
-	
+	list_append(&fibril->link, &ready_list);
 	futex_unlock(&fibril_futex);
 }
@@ -363,8 +339,6 @@
 {
 	futex_lock(&fibril_futex);
-	
 	if (!list_empty(&manager_list))
 		list_remove(list_first(&manager_list));
-	
 	futex_unlock(&fibril_futex);
 }
@@ -380,29 +354,4 @@
 }
 
-/** Disable preemption
- *
- * If the fibril wants to send several message in a row and does not want to be
- * preempted, it should start async_serialize_start() in the beginning of
- * communication and async_serialize_end() in the end. If it is a true
- * multithreaded application, it should protect the communication channel by a
- * futex as well.
- *
- */
-void fibril_inc_sercount(void)
-{
-	serialization_count++;
-}
-
-/** Restore the preemption counter to the previous state. */
-void fibril_dec_sercount(void)
-{
-	serialization_count--;
-}
-
-int fibril_get_sercount(void)
-{
-	return serialization_count;
-}
-
 /** @}
  */
Index: uspace/lib/c/generic/fibril_synch.c
===================================================================
--- uspace/lib/c/generic/fibril_synch.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/c/generic/fibril_synch.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -105,7 +105,4 @@
 	fibril_t *f = (fibril_t *) fibril_get_id();
 
-	if (fibril_get_sercount() != 0)
-		abort();
-
 	futex_down(&async_futex);
 	if (fm->counter-- <= 0) {
@@ -197,7 +194,4 @@
 	fibril_t *f = (fibril_t *) fibril_get_id();
 	
-	if (fibril_get_sercount() != 0)
-		abort();
-
 	futex_down(&async_futex);
 	if (frw->writers) {
@@ -224,7 +218,4 @@
 	fibril_t *f = (fibril_t *) fibril_get_id();
 	
-	if (fibril_get_sercount() != 0)
-		abort();
-
 	futex_down(&async_futex);
 	if (frw->writers || frw->readers) {
@@ -461,9 +452,9 @@
 			if (rc == ETIMEOUT && timer->state == fts_active) {
 				timer->state = fts_fired;
-				timer->handler_running = true;
+				timer->handler_fid = fibril_get_id();
 				fibril_mutex_unlock(timer->lockp);
 				timer->fun(timer->arg);
 				fibril_mutex_lock(timer->lockp);
-				timer->handler_running = false;
+				timer->handler_fid = 0;
 			}
 			break;
@@ -477,6 +468,6 @@
 	/* Acknowledge timer fibril has finished cleanup. */
 	timer->state = fts_clean;
+	fibril_condvar_broadcast(&timer->cv);
 	fibril_mutex_unlock(timer->lockp);
-	free(timer);
 
 	return 0;
@@ -525,5 +516,11 @@
 	timer->state = fts_cleanup;
 	fibril_condvar_broadcast(&timer->cv);
+
+	/* Wait for timer fibril to terminate */
+	while (timer->state != fts_clean)
+		fibril_condvar_wait(&timer->cv, timer->lockp);
 	fibril_mutex_unlock(timer->lockp);
+
+	free(timer);
 }
 
@@ -608,6 +605,16 @@
 	assert(fibril_mutex_is_locked(timer->lockp));
 
-	while (timer->handler_running)
+	while (timer->handler_fid != 0) {
+		if (timer->handler_fid == fibril_get_id()) {
+			printf("Deadlock detected.\n");
+			stacktrace_print();
+			printf("Fibril %zx is trying to clear timer %p from "
+			    "inside its handler %p.\n",
+			    fibril_get_id(), timer, timer->fun);
+			abort();
+		}
+
 		fibril_condvar_wait(&timer->cv, timer->lockp);
+	}
 
 	old_state = timer->state;
Index: uspace/lib/c/generic/getopt.c
===================================================================
--- uspace/lib/c/generic/getopt.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/c/generic/getopt.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -95,11 +95,8 @@
  * Compute the greatest common divisor of a and b.
  */
-static int
-gcd(a, b)
-	int a;
-	int b;
+static int gcd(int a, int b)
 {
 	int c;
-
+	
 	c = a % b;
 	while (c != 0) {
@@ -108,5 +105,5 @@
 		c = a % b;
 	}
-	   
+	
 	return b;
 }
@@ -117,10 +114,6 @@
  * in each block).
  */
-static void
-permute_args(panonopt_start, panonopt_end, opt_end, nargv)
-	int panonopt_start;
-	int panonopt_end;
-	int opt_end;
-	char **nargv;
+static void permute_args(int panonopt_start, int panonopt_end, int opt_end,
+    char **nargv)
 {
 	int cstart, cyclelen, i, j, ncycle, nnonopts, nopts, pos;
@@ -157,9 +150,5 @@
  *  Returns -2 if -- is found (can be long option or end of options marker).
  */
-static int
-getopt_internal(nargc, nargv, options)
-	int nargc;
-	char **nargv;
-	const char *options;
+static int getopt_internal(int nargc, char **nargv, const char *options)
 {
 	const char *oli;				/* option letter list index */
@@ -299,9 +288,5 @@
  *	Parse argc/argv argument vector.
  */
-int
-getopt(nargc, nargv, options)
-	int nargc;
-	char * const *nargv;
-	const char *options;
+int getopt(int nargc, char * const *nargv, const char *options)
 {
 	int retval;
@@ -332,11 +317,6 @@
  *	Parse argc/argv argument vector.
  */
-int
-getopt_long(nargc, nargv, options, long_options, idx)
-	int nargc;
-	char * const *nargv;
-	const char *options;
-	const struct option *long_options;
-	int *idx;
+int getopt_long(int nargc, char * const *nargv, const char *options,
+    const struct option *long_options, int *idx)
 {
 	int retval;
Index: uspace/lib/c/generic/inet.c
===================================================================
--- uspace/lib/c/generic/inet.c	(revision fc7bf198e20e68849d91546bbc5a2a24c943840e)
+++ uspace/lib/c/generic/inet.c	(revision cf3aee195010da61f58b4c6e8daa8d03620c0a4e)
@@ -177,4 +177,5 @@
 	
 	dgram.tos = IPC_GET_ARG1(*icall);
+	dgram.iplink = IPC_GET_ARG2(*icall);
 	
 	ipc_callid_t callid;
